﻿using System;

namespace _01Handy
{
    class Handy
    {
        public string Name { get; private set; }
        private int id;

        private static int naechsteId = 1000;
        private static int handyCount = 0;

        public static int HandyCount { get => handyCount; }
        //public Handy(string name, int Id)
        //{
        //    this.name = name;
        //    id = Id;
        //}

        public Handy(string name)
        {
            handyCount++;
            this.Name = name;
            id = naechsteId;
            naechsteId++;
        }

        //public int getId()
        //{
        //    return id;
        //}
        public int getId() => id;
        public void setId(int Wert)
        {
            if (Wert > 0)
                id = Wert;
            else
                throw new ArgumentOutOfRangeException("Id muss positiv sein!");
        }
        public static int Id
        {
            get => naechsteId;
            set
            {
                if (value >= naechsteId)
                    naechsteId = value;
                else
                    throw new ArgumentOutOfRangeException("Id muss positiv sein!");
            }
        }
        public int Id2 { get; private set; }

        public void IdAusgeben()
        {
            Console.WriteLine(this.id);
        }
        public override string ToString()
            => $"Handy: Name: {Name}, Id: {id}";
    }
    class HandyShop
    {
        private Handy[] handyFeld;
        private static int anzGespeicherteHandies = 0;

        public HandyShop(int AnzHandies)
        {
            handyFeld = new Handy[AnzHandies];
        }

        public void AddHandy(Handy h)
        {
            handyFeld[anzGespeicherteHandies++] = h;
        }
        public Handy this[int k]
        {
            get => handyFeld[k];
            set
            {
                if (handyFeld[k] == null)
                    handyFeld[k] = value;
                else
                    throw new Exception("Speicherplatz schon belegt!");
            }
        }
        public Handy this[string gesName]
        {
            get
            {
                for (int i = 0; i < handyFeld.Length; i++)
                {
                    if (handyFeld[i] != null && handyFeld[i].Name == gesName)
                        return handyFeld[i];
                }
                return null;
            }
        }
    }


    class Program
    {

        static void Main(string[] args)
        {
            Console.WriteLine($"Anzahl Handies: {Handy.HandyCount}");
            Handy.Id = 1000;
            Handy h1 = new Handy("Anton");
            Handy h2 = new Handy("Berta");
            Handy h3 = h1;

            #region Intro
            h3.IdAusgeben();

            int h2Id = h2.getId();
            h2.setId(5000);

            h2.setId(h2.getId() + 1);
            Console.WriteLine(h2.getId());

            Handy.Id = 5000;
            Handy.Id++;

            Console.WriteLine(h2);
            // h2 --> h2.ToString() {string}
            #endregion

            HandyShop shop = new HandyShop(1000);
            shop.AddHandy(new Handy("Claudia"));
            shop.AddHandy(new Handy("Dieter"));
            Console.WriteLine(shop[1]);
            shop[0].IdAusgeben();

            shop[4] = new Handy("Emil");
            Console.WriteLine(shop["Emil"]);
        }
    }
}
