﻿namespace HTML
{
  public class DocumentType : ITagged
  {
    public string TagId => "!DOCTYPE html";
  }

  public class LineBreak : ITagged 
  {
    public string TagId => "br/";
  }

  public abstract class Nested : INested
  {
    object[] elements;

    public Nested(object[] elements) { this.elements = elements; }

    public object[] Elements => elements;
  }

  public class Html : Nested, ITagged
  {
    public Html(params object[] elements) : base(elements) { }

    public string TagId => "html";
  }

  public class Head : Nested, ITagged
  {
    public Head(params object[] elements) : base(elements) { }

    public string TagId => "head";
  }

  public class Body : Nested, ITagged
  {
    public Body(params object[] elements) : base(elements) { }

    public string TagId => "body";
  }

  public class Paragraph : Nested, ITagged
  {
    public Paragraph(params object[] elements) : base(elements) { }

    public string TagId => "p";
  }

  public class Title : Nested, ITagged
  {
    public Title(params object[] elements) : base(elements) { }

    public string TagId => "title";
  }

  public class Heading : Nested, ITagged
  {
    public Heading(params object[] elements) : base(elements) { }

    public string TagId => "h1";
  }

  public class Bold : Nested, ITagged
  {
    public Bold(params object[] elements) : base(elements) { }

    public string TagId => "b";
  }

  public class Italic : Nested, ITagged
  {
    public Italic(params object[] elements) : base(elements) { }

    public string TagId => "i";
  }
}