﻿namespace HTML
{
  // HTML engine for generation of a HTML string from an array of HTML tag objects:

  public interface ITagged { string TagId { get; } }

  public interface INested { object[] Elements { get; } }

  public static class Engine
  {
    public static string Generate(params object[] elements)
    {
      string content = "";

      for (uint index = 0; index < elements.Length; ++index)
      {
        INested nested = elements[index] as INested;
        ITagged tagged = elements[index] as ITagged;

        if (nested != null)
        {
          if (tagged != null)
          {
            content += "<" + tagged.TagId + ">" + Generate(nested.Elements) + "</" + tagged.TagId + ">";
          }
          else
          {
            content += Generate(nested.Elements);
          }

          content += (index + 1 < elements.Length && elements[index + 1] is INested) ? "\n" : "";
        }
        else if (tagged != null)
        {
          content += "<" + tagged.TagId + ">\n";
        }
        else
        {
          content += elements[index].ToString();
        }
      }

      return elements.Length == 1 && !(elements[0] is INested) ? content : "\n" + content + "\n";
    }
  }
}