﻿using System;

namespace _18_Exceptions
{
    class MeinFehler : Exception
    {
        //public string Fehler;
        public int Code { get; set; }
        public MeinFehler(string fehler, int x) : base(fehler)
        {
            //Fehler = fehler;
            Code = x;
        }
    }
    class Program
    {
        static void F2(int x)
        {
            Console.WriteLine("Start von F2");
            try
            {
                if (x < 0)
                    throw new ArgumentOutOfRangeException("F2: Zahl muss positiv sein");
            }
            finally
            {
                Console.WriteLine("Finally-Teil von F2");
            }
            Console.WriteLine("Ende von F2");
        }
        static void F1(int x)
        {
            try
            {
                Console.WriteLine("Start von F1");
                F2(x);
                if (x < 0)
                    throw new MeinFehler("F1: Wert muss positiv sein", x);
                if (x == 0)
                    throw new ArgumentException("F1: Wert darf nicht 0 sein");
            }
            catch (ArgumentOutOfRangeException)
            {
                Console.WriteLine("F1: Argument out of Range Exception");
                throw;
            }
            finally
            {
                Console.WriteLine("Finally von F1");
            }
            Console.WriteLine($"Ende von F1: Wert: {x}");
        }
        static void Main(string[] args)
        {
            try
            {
                F1(-10);
                F1(0);
                F1(20);
            }
            catch (MeinFehler mf)
            {
                Console.WriteLine($"Main: Mein Fehler: {mf.Message} Falscher Wert: {mf.Code}");
            }
            catch (Exception e)
            {
                Console.WriteLine("Main: Allgemeiner Fehler: "+e.Message);
            }
            finally
            {
                Console.WriteLine("Finally in Main");
            }
            Console.WriteLine("Letzte Anweisung des Programms");
        }
    }
}
