﻿using System;

namespace _21_IntroDelegates
{
    class Xxx
    {
        double x;
        string txt;
        public Xxx(string s, double w) { txt = s;  x = w; }
        public double Plus10(double w)
        {
            Console.WriteLine($"{txt}: {x} - {w}");
            return w + 10;
        }
        public static double Mal3(double w) => 3 * w;
    }
    class Program
    {
        delegate double MyFunc(double xx);

        static void Wertetabelle(double von, double bis, MyFunc fkt, string beschr1, string beschr2)
        {
            Console.WriteLine($"{beschr1,10}   {beschr2,10}");
            for (double x = von; x <= bis; x+=(bis-von)/5)
            {
                Console.WriteLine($"{x,10:f2}   {fkt(x),10:f4}");
            }
            Console.WriteLine("---------------------------------");
        }
        static double Sq(double x) { return x * x; }
        static void Main(string[] args)
        {
            Wertetabelle(0, 5, Math.Sin, "X-Wert","sin()");
            Wertetabelle(1, 10, Sq, "x","x^2");
            Wertetabelle(1, 6, delegate (double x) { return 2 * x; }, "x", "2*x");
            Wertetabelle(1, 6, x => x + 1, "x", "x+1");
            // Bei Lambda-Ausdrücken mit mehr Parametern (x,y) => ...
            // ohne Parameter () => ...
            Xxx myObj1 = new Xxx("Hans", 10);
            Xxx myObj2 = new Xxx("Franz", 11);
            Wertetabelle(1, 6, myObj1.Plus10, "x", "x+10");
            Wertetabelle(1, 6, myObj2.Plus10, "x", "x+10");
            Wertetabelle(1, 6, Xxx.Mal3, "x", "x*3");
        }
    }
}
