﻿using System;

namespace _22_Informationsverteiler
{
    
    class MessageBox
    {
        public delegate void Message(string txt);
        public event Message callback=null;
            // event-Delegates schränken die Verwendungsmöglichkeiten des
            // Delegates auf += und -= für Methoden außerhalb dieser Klasse ein!
        public void Send(string txt)
        {
            // z.B. Validierung des Inhalts von "txt"
            callback?.Invoke(">>> " + txt);  // if (callback != null) callback(...);
        }
    }

    class Person
    {
        public string Name { get; set; }
        public Person(string Name) { this.Name = Name; }
        public void MyPrint(string x) { Console.WriteLine( $"MyName {Name}: {x}"); }
    }
    class Program
    {

        static void Main(string[] args)
        {
            MessageBox mb = new MessageBox();
            Person p1 = new Person("Anton");
            Person p2 = new Person("Berta");

            mb.Send("Noch keine Methode registriert");

            mb.callback += Console.WriteLine;
            mb.callback += p1.MyPrint;
            mb.callback += p2.MyPrint;

            // mb.callback("Hallo");  -- ist nicht erlaubt. Nur Methoden in der Klasse MessageBox dürfen callback aufrufen
            mb.Send("Hallo");
            Console.WriteLine("------------------");


            mb.callback -= Console.WriteLine;
            mb.Send("Hallo zwei");
            // mb.callback("Hallo")
            //   --> Console.WriteLine("Hallo");
            //   --> p1.MyPrint("Hallo");
            //   --> p2.MyPrint("Hallo");

        }
    }
}
