﻿using System;
using System.Collections.Generic;

namespace _23_ApplyAll
{
    class Program
    {
        delegate U MyFunctn<U>(U x);
        static T[] ApplyAll<T>(MyFunctn<T> f, params T[] feld)
        {
            T[] erg = new T[feld.Length];
            for (int i = 0; i < feld.Length; i++)
                erg[i] = f(feld[i]);
            return erg;
        }
        static T[] Select<T>(Predicate<T> test, params T[] feld)
        {
            List<T> erg = new List<T>();

            for (int i = 0; i < feld.Length; i++)
            {
                if (test(feld[i]))
                    erg.Add(feld[i]);
            }
            return erg.ToArray();
        }
        static void Print<T>(T[] feld)
        {
            foreach (var item in feld)
            {
                Console.Write(item + "  ");
            }
            Console.WriteLine();
        }
        static void Main(string[] args)
        {
            int[] meinFeld = { 10, 20, 30, 40, 50 };
            Print(ApplyAll(x => x + 1, meinFeld));
            Print(Select(x => x % 3 == 0, ApplyAll(x => x + 1, meinFeld)));
            Print(meinFeld);

            Print(ApplyAll(s => s.ToUpper(), "Anton", "Berta", "Claudia", "Dieter"));

        }
    }
}
