﻿using System;

namespace _23_DelegateVerkettung
{
    class Pipeline
    {
        public delegate string Aktion(string txt);
        public delegate bool FilterFctn(string txt);
        public Aktion ops = null;
        public Predicate<string> tests = null;

        public string DoIt(string text)
        {
            if (ops != null)
            {
                //string s = text;
                foreach (Aktion methode in ops.GetInvocationList())
                // GetInvocationList() liefert ein Feld mit allen im Deleg. gespeicherten Methoden
                {
                    text = methode(text);     // ~ ToUpper("Hallo Welt") --> "HALLO WELT"
                                        // ~ Left("HALLO WELT") --> "HALLO"
                }
                return text;
            }
            return null;
        }
        public bool IsOK(string text)
        {
            if (tests != null)
            { // Predicate<string> ~ bool TestFunktion(string)
                foreach (Predicate<string> test in tests.GetInvocationList())
                {
                    if (test(text) == false)
                        return false;
                }
                return true;
            }
            return false;
        }
    }
    class Image
    {
        int[,] pix = new int[6000, 4000];
        public void Helligkeit() { }
        public void Kontrast() { }
        public static void Toenung(Image img) { }
    }

    delegate void ImgAktionen();
    class ImageOps
    {
        public ImgAktionen ops = null;
    }
    
    class Program
    {
        static string ToUpper(string s) => s.ToUpper();
        static string Left(string s) => s.Substring(0, 9);

        static bool MehrAls5Zeichen(string s) => s.Length > 6;
        static bool EnthaeltHallo(string s) => s.Contains("Hallo");


        static void Main(string[] args)
        {
            Pipeline p = new Pipeline();
            p.ops += ToUpper;
            p.ops += Left;
            // p.ops("Hallo Welt")
            //   --> ToUpper("Hallo Welt")
            //   --> Left("Hallo Welt")
            string s = p.DoIt("Hallo Welt");
            Console.WriteLine(">" + s + "<");


            p.tests += MehrAls5Zeichen;
            p.tests += EnthaeltHallo;

            if (p.IsOK("Hallo Welt"))
                Console.WriteLine("String erfüllt alle Eigenschaften");
            else
                Console.WriteLine("Eine oder mehrere Eigenschaften nicht erfüllt");

            Image i1 = new Image();
            ImageOps aktionen = new ImageOps();
            aktionen.ops += i1.Helligkeit;
            aktionen.ops += i1.Kontrast;
            aktionen.ops();
        
        }
    }
}
