﻿using System;

namespace _23_Kontostandueberpruefung
{
    delegate bool Kontostandueberpruefung(double x);

    class Bankkonto
    {
        public int Kontonummer { get; set; }
        public double Kontostand { get; set; }
        public bool UeberprüfeKontostand(Kontostandueberpruefung f)
        {
            return f(Kontostand);
        }
    }
    class Kontoverwaltung
    {
        public static void UeberpruefeKonto(Bankkonto konto, Kontostandueberpruefung test)
        {
            if (konto.UeberprüfeKontostand(test))
                Console.WriteLine("Das Konto hat ausreichend Deckung");
            else
                Console.WriteLine("Der Kontostand ist zu niedrig");
        }
        public static bool StandardKontostandUeberpruefung(double x) => x >= 0;
        public static bool MindestKontostandUeberpruefung(double x) => x >= 1000;
    }
    class Program
    {
        static void Main(string[] args)
        {
            Bankkonto k1 = new Bankkonto() { Kontonummer = 12345, Kontostand = 500 };
            Kontoverwaltung.UeberpruefeKonto(k1, Kontoverwaltung.MindestKontostandUeberpruefung);
            Kontoverwaltung.UeberpruefeKonto(k1, Kontoverwaltung.StandardKontostandUeberpruefung);
        }
    }
}
