﻿using System;
using System.Linq;

namespace _10_LINQ_Intro
{
    class Program
    {
        /// <summary>
        /// Zeigt die Erzeugung eines anonymen Typs und die Zuweisung an eine Variable,
        /// die als var - Typ deklariert ist
        /// </summary>
        private static void AnonymousTypes()
        {
            var x = 123;

            var r1 = new { Name = "Wienkop", Tel = "1614", Alter = 59 };
            var r2 = new { Name = "Wienkop", Tel = "1614" };

            Console.WriteLine(r1);
            // r1.Name = r2.Name;     // geht nicht: Name ist read-only

            Console.WriteLine(r2);
            string s = r1.Name;
            var result = new { r1.Name, Laenge = r1.Name.Length };
            Console.WriteLine(result);
        }



        /// <summary>
        /// Beispiel für einen LINQ-Aufruf
        /// </summary>
        private static void Main(string[] args)
        {
            //AnonymousTypes();
            string[] wörter = {
                                  "Anton", "Berta", "Charles", "Dieter", "Emma", "Franz", "Gustav", "Heiner", "Ida",
                                  "Johanna", "Klaus", "Ludwig", "Manni", "Norbert", "Otto", "Paul", "Quasimodo", "Rainer",
                                  "Stefan", "Thorsten", "Uwe", "Victoria", "Willi", "Xaver", "Yvonne", "Zacharias"
                              };


            //var res = from w in wörter
            //          where w.Length < 6        // Namen mit weniger als 6 Zeichen
            //          orderby w descending      // Absteigend sortieren
            //          select new { OrgName = w, GrossName = w.ToUpper(), Länge = w.Length };

            //foreach (var r in res)
            //{
            //    Console.WriteLine(r);
            //}

            Console.WriteLine("******************");


            var res2 = from w in wörter
                       where w.Length < 6
                       group w by w.Length;

            foreach (var group in res2)
            {
                Console.WriteLine("Länge: " + group.Key);
                foreach (string r in group)
                {
                    Console.WriteLine("  " + r);
                }
            }
        }
    }
}
