﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;

namespace _91_GenerischeListe
{
    //// Gibt es eine gespeicherte Position???
    //yield return 1; // merke Prog.-Position! return 1;
    //yield return '2'; // merke Prog.-Position! return 2;
    //yield return 3; // merke Prog.-Position! return 3;
    //// Methodenende; Gespeicherte Position = null;
    class Person : IComparable<Person>
    {
        public string Name { get; set; }

        public int CompareTo( Person other)
        {
            throw new NotImplementedException();
        }
    }
    class GenerischeListe<T> where T:IComparable<T>
    {
        class Node
        {
            public T data;
            public Node next;
            public Node(T data) { this.data = data; next = null; }
        }

        private Node first = null, last = null;
        public void AddLast(T data)
        {
            Node newNode = new Node(data);
            if (first == null)
            {
                first = last = newNode;
            }
            else  // Es gibt schon Listenelemente
            {
                last.next = newNode;
                last = newNode;
            }            
        }
        public void AddFirst(T data)
        {
            Node newNode = new Node(data);
            if (first == null)
            {
                first = last = newNode;
            }
            else  // Es gibt schon Listenelemente
            {
                newNode.next = first;
                first = newNode;
            }
        }

        public IEnumerator<T> GetEnumerator()
        {
            for (Node node = first; node != null; node = node.next)
                yield return node.data;
        }
        public IEnumerable<T> Filter(Predicate<T> testFn)
        {
            for (Node node = first; node != null; node = node.next)
                if (testFn(node.data))
                    yield return node.data;
        }
    }
    class Program
    {
        static bool IstUngerade(int x)
        {
            if (x % 2 == 1)
                return true;
            else
                return false;
        }
        static void Main(string[] args)
        {
            GenerischeListe<int> l1 = new GenerischeListe<int>();
            l1.AddLast(1);
            l1.AddFirst(2);
            l1.AddLast(3);
            foreach (var item in l1.Filter(x => x % 2 == 1))  // x=>x%2==1
            {
                Console.WriteLine(item);
            }
            GenerischeListe<Person> pl = new GenerischeListe<Person>();
        }
    }
}
